Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Parameters.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Parameters.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Parameters.cpp	(revision 88)
@@ -20,138 +20,157 @@
 #define FUNCTION "Read_unit::Parameters"
   Parameters::Parameters (uint32_t size_read_queue         ,
-			  uint32_t size_reservation_station,
-			  uint32_t nb_context              ,
-			  uint32_t nb_front_end            ,
-			  uint32_t nb_ooo_engine           ,
-			  uint32_t nb_packet               ,
-			  uint32_t size_general_data       ,
-			  uint32_t size_special_data       ,
-			  uint32_t nb_general_register     ,
-			  uint32_t nb_special_register     ,
-			  uint32_t nb_gpr_write            ,
-			  uint32_t nb_spr_write            ,
-			  uint32_t size_store_queue        ,
-			  uint32_t size_load_queue         ,
-			  uint32_t nb_inst_retire          ,
-			  uint32_t nb_bypass_write         ,
-			  uint32_t nb_bypass_memory        ):
-    _size_read_queue          (size_read_queue         ),
-    _size_reservation_station (size_reservation_station),
-    _nb_context               (nb_context              ),
-    _nb_front_end             (nb_front_end            ),
-    _nb_ooo_engine            (nb_ooo_engine           ),
-    _nb_packet                (nb_packet               ),
-    _size_general_data        (size_general_data       ),
-    _size_special_data        (size_special_data       ),
-    _nb_general_register      (nb_general_register     ),
-    _nb_special_register      (nb_special_register     ),
-    _nb_gpr_write             (nb_gpr_write            ),
-    _nb_spr_write             (nb_spr_write            ),
-    _size_store_queue         (size_store_queue        ),
-    _size_load_queue          (size_load_queue         ),
-    _nb_inst_retire           (nb_inst_retire          ),
-    _nb_bypass_write          (nb_bypass_write         ),
-    _nb_bypass_memory         (nb_bypass_memory        ),
-    
-    _nb_gpr_read              (2),
-    _nb_spr_read              (1),    
-    _size_context_id          (log2(nb_context         )),
-    _size_front_end_id        (log2(nb_front_end       )),
-    _size_ooo_engine_id       (log2(nb_ooo_engine      )),
-    _size_packet_id           (log2(nb_packet          )),
-    _size_general_register    (log2(nb_general_register)),
-    _size_special_register    (log2(nb_special_register)),
-    
-    _have_port_context_id     (_size_context_id   >0),
-    _have_port_front_end_id   (_size_front_end_id >0),
-    _have_port_ooo_engine_id  (_size_ooo_engine_id>0),
-    _have_port_packet_id      (_size_packet_id    >0),
-    _have_port_load_queue_ptr (_size_load_queue   >1)
+                          uint32_t size_reservation_station,
+                          uint32_t nb_context              ,
+                          uint32_t nb_front_end            ,
+                          uint32_t nb_ooo_engine           ,
+                          uint32_t nb_packet               ,
+                          uint32_t size_general_data       ,
+                          uint32_t size_special_data       ,
+                          uint32_t nb_general_register     ,
+                          uint32_t nb_special_register     ,
+                          uint32_t nb_gpr_write            ,
+                          uint32_t nb_spr_write            ,
+                          uint32_t size_store_queue        ,
+                          uint32_t size_load_queue         ,
+                          uint32_t nb_inst_retire          ,
+                          uint32_t nb_bypass_write         ,
+                          uint32_t nb_bypass_memory        ,
+                          bool     is_toplevel)
   {
     log_printf(FUNC,Read_unit,FUNCTION,"Begin");
 
+    _size_read_queue          = size_read_queue         ;
+    _size_reservation_station = size_reservation_station;
+    _nb_context               = nb_context              ;
+    _nb_front_end             = nb_front_end            ;
+    _nb_ooo_engine            = nb_ooo_engine           ;
+    _nb_packet                = nb_packet               ;
+    _nb_general_register      = nb_general_register     ;
+    _nb_special_register      = nb_special_register     ;
+    _nb_gpr_write             = nb_gpr_write            ;
+    _nb_spr_write             = nb_spr_write            ;
+    _nb_inst_retire           = nb_inst_retire          ;
+    _nb_bypass_write          = nb_bypass_write         ;
+    _nb_bypass_memory         = nb_bypass_memory        ;
+    
+    _nb_gpr_read              = 2;
+    _nb_spr_read              = 1;    
+
     _param_read_queue = new morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_read_unit::read_unit::read_queue::Parameters
-      ( _size_read_queue    
-	,_nb_context         
-	,_nb_front_end       
-	,_nb_ooo_engine
-	,_nb_packet          
-	,_size_general_data  
-	,_size_special_data  
-	,_nb_general_register
-	,_nb_special_register
-	,_nb_gpr_write
-	,_nb_spr_write
-	,_size_store_queue
-	,_size_load_queue 
-	);
+      (_size_read_queue    
+      ,_nb_context         
+      ,_nb_front_end       
+      ,_nb_ooo_engine
+      ,_nb_packet          
+      , size_general_data  
+      , size_special_data  
+      ,_nb_general_register
+      ,_nb_special_register
+      ,_nb_gpr_write
+      ,_nb_spr_write
+      , size_store_queue
+      , size_load_queue 
+      );
 
     _param_reservation_station = new morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_read_unit::read_unit::reservation_station::Parameters
-	(size_reservation_station
-	 ,nb_inst_retire     
-	 ,nb_context         
-	 ,nb_front_end       
-	 ,nb_ooo_engine
-	 ,nb_packet          
-	 ,size_general_data  
-	 ,size_special_data  
-	 ,nb_general_register
-	 ,nb_special_register
-	 ,nb_gpr_write
-	 ,nb_spr_write
-	 ,nb_bypass_write 
-	 ,nb_bypass_memory
-	 ,size_store_queue
-	 ,size_load_queue 
-	 );
-
+        (_size_reservation_station
+        ,_nb_inst_retire     
+        ,_nb_context         
+        ,_nb_front_end       
+        ,_nb_ooo_engine
+        ,_nb_packet          
+        , size_general_data  
+        , size_special_data  
+        ,_nb_general_register
+        ,_nb_special_register
+        ,_nb_gpr_write
+        ,_nb_spr_write
+        ,_nb_bypass_write 
+        ,_nb_bypass_memory
+        , size_store_queue
+        , size_load_queue 
+        );
 
     test();
+
+    if (is_toplevel)
+      {
+        _size_context_id          = log2(nb_context         );
+        _size_front_end_id        = log2(nb_front_end       );
+        _size_ooo_engine_id       = log2(nb_ooo_engine      );
+        _size_rob_ptr             = log2(nb_packet          );
+        _size_general_register    = log2(nb_general_register);
+        _size_special_register    = log2(nb_special_register);
+        _size_general_data        = size_general_data       ;
+        _size_special_data        = size_special_data       ;
+        _size_store_queue_ptr     = log2(size_store_queue   );
+        _size_load_queue_ptr      = log2(size_load_queue    );
+        
+        _have_port_context_id     = _size_context_id     > 0;
+        _have_port_front_end_id   = _size_front_end_id   > 0;
+        _have_port_ooo_engine_id  = _size_ooo_engine_id  > 0;
+        _have_port_rob_ptr        = _size_rob_ptr        > 0;
+        _have_port_load_queue_ptr = _size_load_queue_ptr > 0;
+
+        copy();
+      }
 
     log_printf(FUNC,Read_unit,FUNCTION,"End");
   };
   
+// #undef  FUNCTION
+// #define FUNCTION "Read_unit::Parameters (copy)"
+//   Parameters::Parameters (Parameters & param):
+//     _size_read_queue          (param._size_read_queue         ),
+//     _size_reservation_station (param._size_reservation_station),
+//     _nb_context               (param._nb_context              ),
+//     _nb_front_end             (param._nb_front_end            ),
+//     _nb_ooo_engine            (param._nb_ooo_engine           ),
+//     _nb_packet                (param._nb_packet               ),
+//     _size_general_data        (param._size_general_data       ),
+//     _size_special_data        (param._size_special_data       ),
+//     _nb_general_register      (param._nb_general_register     ),
+//     _nb_special_register      (param._nb_special_register     ),
+//     _nb_gpr_write             (param._nb_gpr_write            ),
+//     _nb_spr_write             (param._nb_spr_write            ),
+//     _size_store_queue         (param._size_store_queue        ),
+//     _size_load_queue          (param._size_load_queue         ),
+//     _nb_inst_retire           (param._nb_inst_retire          ),
+//     _nb_bypass_write          (param._nb_bypass_write         ),
+//     _nb_bypass_memory         (param._nb_bypass_memory        ),
+
+//     _nb_gpr_read              (param._nb_gpr_read             ),
+//     _nb_spr_read              (param._nb_spr_read             ),    
+//     _size_context_id          (param._size_context_id         ),
+//     _size_front_end_id        (param._size_front_end_id       ),
+//     _size_ooo_engine_id       (param._size_ooo_engine_id      ),
+//     _size_packet_id           (param._size_packet_id          ),
+//     _size_general_register    (param._size_general_register   ),
+//     _size_special_register    (param._size_special_register   ),
+
+//     _have_port_context_id     (param._have_port_context_id    ),
+//     _have_port_front_end_id   (param._have_port_front_end_id  ),
+//     _have_port_ooo_engine_id  (param._have_port_ooo_engine_id ),
+//     _have_port_packet_id      (param._have_port_packet_id     ),
+//     _have_port_load_queue_ptr (param._have_port_load_queue_ptr)
+//   {
+//     log_printf(FUNC,Read_unit,FUNCTION,"Begin");
+
+//     _param_read_queue          = param._param_read_queue         ;
+//     _param_reservation_station = param._param_reservation_station;
+
+//     test();
+
+//     log_printf(FUNC,Read_unit,FUNCTION,"End");
+//   };
+
 #undef  FUNCTION
-#define FUNCTION "Read_unit::Parameters (copy)"
-  Parameters::Parameters (Parameters & param):
-    _size_read_queue          (param._size_read_queue         ),
-    _size_reservation_station (param._size_reservation_station),
-    _nb_context               (param._nb_context              ),
-    _nb_front_end             (param._nb_front_end            ),
-    _nb_ooo_engine            (param._nb_ooo_engine           ),
-    _nb_packet                (param._nb_packet               ),
-    _size_general_data        (param._size_general_data       ),
-    _size_special_data        (param._size_special_data       ),
-    _nb_general_register      (param._nb_general_register     ),
-    _nb_special_register      (param._nb_special_register     ),
-    _nb_gpr_write             (param._nb_gpr_write            ),
-    _nb_spr_write             (param._nb_spr_write            ),
-    _size_store_queue         (param._size_store_queue        ),
-    _size_load_queue          (param._size_load_queue         ),
-    _nb_inst_retire           (param._nb_inst_retire          ),
-    _nb_bypass_write          (param._nb_bypass_write         ),
-    _nb_bypass_memory         (param._nb_bypass_memory        ),
-
-    _nb_gpr_read              (param._nb_gpr_read             ),
-    _nb_spr_read              (param._nb_spr_read             ),    
-    _size_context_id          (param._size_context_id         ),
-    _size_front_end_id        (param._size_front_end_id       ),
-    _size_ooo_engine_id       (param._size_ooo_engine_id      ),
-    _size_packet_id           (param._size_packet_id          ),
-    _size_general_register    (param._size_general_register   ),
-    _size_special_register    (param._size_special_register   ),
-
-    _have_port_context_id     (param._have_port_context_id    ),
-    _have_port_front_end_id   (param._have_port_front_end_id  ),
-    _have_port_ooo_engine_id  (param._have_port_ooo_engine_id ),
-    _have_port_packet_id      (param._have_port_packet_id     ),
-    _have_port_load_queue_ptr (param._have_port_load_queue_ptr)
+#define FUNCTION "Read_unit::~Parameters"
+  Parameters::~Parameters (void) 
   {
     log_printf(FUNC,Read_unit,FUNCTION,"Begin");
 
-    _param_read_queue          = param._param_read_queue         ;
-    _param_reservation_station = param._param_reservation_station;
-
-    test();
+    delete _param_read_queue;
+    delete _param_reservation_station;
 
     log_printf(FUNC,Read_unit,FUNCTION,"End");
@@ -159,11 +178,11 @@
 
 #undef  FUNCTION
-#define FUNCTION "Read_unit::~Parameters"
-  Parameters::~Parameters () 
+#define FUNCTION "Read_unit::copy"
+  void Parameters::copy (void) 
   {
     log_printf(FUNC,Read_unit,FUNCTION,"Begin");
 
-    delete _param_read_queue;
-    delete _param_reservation_station;
+    COPY(_param_read_queue);
+    COPY(_param_reservation_station);
 
     log_printf(FUNC,Read_unit,FUNCTION,"End");
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Parameters_print.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Parameters_print.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Parameters_print.cpp	(revision 88)
@@ -39,6 +39,6 @@
     xml.singleton_begin("nb_gpr_write            "); xml.attribut("value",toString(_nb_gpr_write            )); xml.singleton_end();
     xml.singleton_begin("nb_spr_write            "); xml.attribut("value",toString(_nb_spr_write            )); xml.singleton_end();
-    xml.singleton_begin("size_store_queue        "); xml.attribut("value",toString(_size_store_queue        )); xml.singleton_end();
-    xml.singleton_begin("size_load_queue         "); xml.attribut("value",toString(_size_load_queue         )); xml.singleton_end();
+//  xml.singleton_begin("size_store_queue        "); xml.attribut("value",toString(_size_store_queue        )); xml.singleton_end();
+//  xml.singleton_begin("size_load_queue         "); xml.attribut("value",toString(_size_load_queue         )); xml.singleton_end();
     xml.singleton_begin("nb_inst_retire          "); xml.attribut("value",toString(_nb_inst_retire          )); xml.singleton_end();
     xml.singleton_begin("nb_bypass_write         "); xml.attribut("value",toString(_nb_bypass_write         )); xml.singleton_end();
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Read_unit.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Read_unit.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Read_unit.cpp	(revision 88)
@@ -38,4 +38,10 @@
     log_printf(FUNC,Read_unit,FUNCTION,"Begin");
 
+#if DEBUG_Read_unit == true
+    log_printf(INFO,Read_unit,FUNCTION,_("<%s> Parameters"),_name.c_str());
+
+    std::cout << *param << std::endl;
+#endif    
+
     log_printf(INFO,Read_unit,FUNCTION,"Allocation");
 
@@ -47,5 +53,5 @@
 
 #ifdef STATISTICS
-    if (_usage & USE_STATISTICS)
+    if (usage_is_set(_usage,USE_STATISTICS))
       {	
 	log_printf(INFO,Read_unit,FUNCTION,"Allocation of statistics");
@@ -56,5 +62,5 @@
 
 #ifdef VHDL
-    if (_usage & USE_VHDL)
+    if (usage_is_set(_usage,USE_VHDL))
       {
 	// generate the vhdl
@@ -66,5 +72,5 @@
 
 #ifdef SYSTEMC
-    if (_usage & USE_SYSTEMC)
+    if (usage_is_set(_usage,USE_SYSTEMC))
       {
 	log_printf(INFO,Read_unit,FUNCTION,"Method - transition");
@@ -90,5 +96,5 @@
 
 #ifdef STATISTICS
-    if (_usage & USE_STATISTICS)
+    if (usage_is_set(_usage,USE_STATISTICS))
       {
 	log_printf(INFO,Read_unit,FUNCTION,"Generate Statistics file");
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Read_unit_allocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Read_unit_allocation.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Read_unit_allocation.cpp	(revision 88)
@@ -48,5 +48,5 @@
 							 ,IN
 							 ,SOUTH,
-							 "Generalist interface"
+							 _("Generalist interface")
 #endif
 							 );
@@ -57,5 +57,5 @@
     // ~~~~~[ Interface "read_unit_in" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      {
-       ALLOC_INTERFACE("read_unit_in", IN, WEST, "Enter of new operation");
+       ALLOC_INTERFACE("read_unit_in", IN, WEST, _("Enter of new operation"));
 
        ALLOC_VALACK_IN    ( in_READ_UNIT_IN_VAL,VAL);
@@ -64,9 +64,9 @@
        ALLOC_SIGNAL_IN ( in_READ_UNIT_IN_FRONT_END_ID         ,"front_end_id"         ,Tcontext_t        ,_param->_size_front_end_id );
        ALLOC_SIGNAL_IN ( in_READ_UNIT_IN_OOO_ENGINE_ID        ,"ooo_engine_id"        ,Tcontext_t        ,_param->_size_ooo_engine_id);
-       ALLOC_SIGNAL_IN ( in_READ_UNIT_IN_PACKET_ID            ,"packet_id"            ,Tpacket_t         ,_param->_size_packet_id    );
+       ALLOC_SIGNAL_IN ( in_READ_UNIT_IN_PACKET_ID            ,"packet_id"            ,Tpacket_t         ,_param->_size_rob_ptr    );
        ALLOC_SIGNAL_IN ( in_READ_UNIT_IN_OPERATION            ,"operation"            ,Toperation_t      ,_param->_size_operation    );
        ALLOC_SIGNAL_IN ( in_READ_UNIT_IN_TYPE                 ,"type"                 ,Ttype_t           ,_param->_size_type         );
-       ALLOC_SIGNAL_IN ( in_READ_UNIT_IN_STORE_QUEUE_PTR_WRITE,"store_queue_ptr_write",Tlsq_ptr_t        ,log2(_param->_size_store_queue));
-       ALLOC_SIGNAL_IN ( in_READ_UNIT_IN_LOAD_QUEUE_PTR_WRITE ,"load_queue_ptr_write" ,Tlsq_ptr_t        ,log2(_param->_size_load_queue));
+       ALLOC_SIGNAL_IN ( in_READ_UNIT_IN_STORE_QUEUE_PTR_WRITE,"store_queue_ptr_write",Tlsq_ptr_t        ,_param->_size_store_queue_ptr);
+       ALLOC_SIGNAL_IN ( in_READ_UNIT_IN_LOAD_QUEUE_PTR_WRITE ,"load_queue_ptr_write" ,Tlsq_ptr_t        ,_param->_size_load_queue_ptr);
        ALLOC_SIGNAL_IN ( in_READ_UNIT_IN_HAS_IMMEDIAT         ,"has_immediat"         ,Tcontrol_t        ,1);
        ALLOC_SIGNAL_IN ( in_READ_UNIT_IN_IMMEDIAT             ,"immediat"             ,Tgeneral_data_t   ,_param->_size_general_data);
@@ -85,5 +85,5 @@
     // ~~~~~[ Interface "read_unit_out" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      {
-       ALLOC1_INTERFACE("read_unit_out", OUT, EAST, "Output of operation. All operand is valid.", _param->_nb_inst_retire);
+       ALLOC1_INTERFACE("read_unit_out", OUT, EAST, _("Output of operation. All operand is valid."), _param->_nb_inst_retire);
 
        ALLOC1_VALACK_OUT   (out_READ_UNIT_OUT_VAL,VAL);
@@ -92,9 +92,9 @@
        ALLOC1_SIGNAL_OUT(out_READ_UNIT_OUT_FRONT_END_ID         ,"front_end_id"         ,Tcontext_t        ,_param->_size_front_end_id    );
        ALLOC1_SIGNAL_OUT(out_READ_UNIT_OUT_OOO_ENGINE_ID        ,"ooo_engine_id"        ,Tcontext_t        ,_param->_size_ooo_engine_id   );
-       ALLOC1_SIGNAL_OUT(out_READ_UNIT_OUT_PACKET_ID            ,"packet_id"            ,Tpacket_t         ,_param->_size_packet_id       );
+       ALLOC1_SIGNAL_OUT(out_READ_UNIT_OUT_PACKET_ID            ,"packet_id"            ,Tpacket_t         ,_param->_size_rob_ptr       );
        ALLOC1_SIGNAL_OUT(out_READ_UNIT_OUT_OPERATION            ,"operation"            ,Toperation_t      ,_param->_size_operation       );
        ALLOC1_SIGNAL_OUT(out_READ_UNIT_OUT_TYPE                 ,"type"                 ,Ttype_t           ,_param->_size_type            );
-       ALLOC1_SIGNAL_OUT(out_READ_UNIT_OUT_STORE_QUEUE_PTR_WRITE,"store_queue_ptr_write",Tlsq_ptr_t        ,log2(_param->_size_store_queue));
-       ALLOC1_SIGNAL_OUT(out_READ_UNIT_OUT_LOAD_QUEUE_PTR_WRITE ,"load_queue_ptr_write" ,Tlsq_ptr_t        ,log2(_param->_size_load_queue ));
+       ALLOC1_SIGNAL_OUT(out_READ_UNIT_OUT_STORE_QUEUE_PTR_WRITE,"store_queue_ptr_write",Tlsq_ptr_t        ,_param->_size_store_queue_ptr);
+       ALLOC1_SIGNAL_OUT(out_READ_UNIT_OUT_LOAD_QUEUE_PTR_WRITE ,"load_queue_ptr_write" ,Tlsq_ptr_t        ,_param->_size_load_queue_ptr);
        ALLOC1_SIGNAL_OUT(out_READ_UNIT_OUT_HAS_IMMEDIAT         ,"has_immediat"         ,Tcontrol_t        ,1                             );
        ALLOC1_SIGNAL_OUT(out_READ_UNIT_OUT_IMMEDIAT             ,"immediat"             ,Tgeneral_data_t   ,_param->_size_general_data    );
@@ -110,5 +110,5 @@
     // ~~~~~[ Interface "gpr_read" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      {
-       ALLOC1_INTERFACE("gpr_read", OUT, SOUTH, "Read port.", _param->_nb_gpr_read);
+       ALLOC1_INTERFACE("gpr_read", OUT, SOUTH, _("Read port."), _param->_nb_gpr_read);
 
        ALLOC1_VALACK_OUT   (out_GPR_READ_VAL,VAL);
@@ -122,5 +122,5 @@
     // ~~~~~[ Interface "spr_read" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      {
-       ALLOC1_INTERFACE("spr_read", OUT, SOUTH, "Read port.", _param->_nb_spr_read);
+       ALLOC1_INTERFACE("spr_read", OUT, SOUTH, _("Read port."), _param->_nb_spr_read);
 
        ALLOC1_VALACK_OUT   (out_SPR_READ_VAL,VAL);
@@ -134,5 +134,5 @@
     // ~~~~~[ Interface "gpr_write" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      {
-       ALLOC1_INTERFACE("gpr_write", IN , SOUTH, "Write port.", _param->_nb_gpr_write);
+       ALLOC1_INTERFACE("gpr_write", IN , SOUTH, _("Write port."), _param->_nb_gpr_write);
 
        ALLOC1_VALACK_IN    ( in_GPR_WRITE_VAL,VAL);
@@ -144,5 +144,5 @@
     // ~~~~~[ Interface "spr_write" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      {
-       ALLOC1_INTERFACE("spr_write", IN , SOUTH, "Write port.", _param->_nb_spr_write);
+       ALLOC1_INTERFACE("spr_write", IN , SOUTH, _("Write port."), _param->_nb_spr_write);
 
        ALLOC1_VALACK_IN    ( in_SPR_WRITE_VAL,VAL);
@@ -154,5 +154,5 @@
     // ~~~~~[ Interface "bypass_write" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      {
-       ALLOC1_INTERFACE("bypass_write", IN , NORTH, "Output of write_queue.", _param->_nb_bypass_write);
+       ALLOC1_INTERFACE("bypass_write", IN , NORTH, _("Output of write_queue."), _param->_nb_bypass_write);
 
        ALLOC1_SIGNAL_IN ( in_BYPASS_WRITE_OOO_ENGINE_ID,"ooo_engine_id",Tcontext_t        ,_param->_size_ooo_engine_id   );
@@ -167,5 +167,5 @@
     // ~~~~~[ Interface "bypass_memory" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      {
-       ALLOC1_INTERFACE("bypass_memory", IN , NORTH, "Output of write_queue.", _param->_nb_bypass_memory);
+       ALLOC1_INTERFACE("bypass_memory", IN , NORTH, _("Output of write_queue."), _param->_nb_bypass_memory);
 
        ALLOC1_SIGNAL_IN ( in_BYPASS_MEMORY_VAL          ,"val"          ,Tcontrol_t        ,1);
@@ -177,10 +177,9 @@
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
 
-    // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
-
      std::string name;
 
      {
        name = _name+"_read_queue";
+       log_printf(INFO,Core,FUNCTION,_("Create   : %s"),name.c_str());
        
        _component_read_queue  = new morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_read_unit::read_unit::read_queue::Read_queue
@@ -200,5 +199,6 @@
      {
        name = _name+"_reservation_station";
-       
+       log_printf(INFO,Core,FUNCTION,_("Create   : %s"),name.c_str());     
+  
        _component_reservation_station  = new morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_read_unit::read_unit::reservation_station::Reservation_station 
 	 (name.c_str()
@@ -219,5 +219,6 @@
      {
        name = _name+"_read_queue";
-       std::cout << "Instance : " << name << std::endl;
+       log_printf(INFO,Core,FUNCTION,_("Instance : %s"),name.c_str());
+
        {
 #ifdef POSITION
@@ -246,5 +247,5 @@
 	 if (_param->_have_port_ooo_engine_id)
 	 _component->port_map(name, "in_READ_QUEUE_IN_OOO_ENGINE_ID"        ,dest, "in_READ_UNIT_IN_OOO_ENGINE_ID"        );
-	 if (_param->_have_port_packet_id)
+	 if (_param->_have_port_rob_ptr)
 	 _component->port_map(name, "in_READ_QUEUE_IN_ROB_ID"               ,dest, "in_READ_UNIT_IN_PACKET_ID"            );
 	 _component->port_map(name, "in_READ_QUEUE_IN_OPERATION"            ,dest, "in_READ_UNIT_IN_OPERATION"            );
@@ -283,5 +284,5 @@
 	 if (_param->_have_port_ooo_engine_id)
 	 _component->port_map(name,"out_READ_QUEUE_OUT_OOO_ENGINE_ID"        ,dest, "in_INSERT_OOO_ENGINE_ID"        );
-	 if (_param->_have_port_packet_id)
+	 if (_param->_have_port_rob_ptr)
 	 _component->port_map(name,"out_READ_QUEUE_OUT_ROB_ID"               ,dest, "in_INSERT_ROB_ID"               );
 	 _component->port_map(name,"out_READ_QUEUE_OUT_OPERATION"            ,dest, "in_INSERT_OPERATION"            );
@@ -379,5 +380,5 @@
      {
        name = _name+"_reservation_station";
-       std::cout << "Instance : " << name << std::endl;
+       log_printf(INFO,Core,FUNCTION,_("Instance : %s"),name.c_str());
        {
 #ifdef POSITION
@@ -407,5 +408,5 @@
 	 if (_param->_have_port_ooo_engine_id)
 	 _component->port_map(name, "in_INSERT_OOO_ENGINE_ID"        ,dest,"out_READ_QUEUE_OUT_OOO_ENGINE_ID"        );
-	 if (_param->_have_port_packet_id)
+	 if (_param->_have_port_rob_ptr)
 	 _component->port_map(name, "in_INSERT_ROB_ID"               ,dest,"out_READ_QUEUE_OUT_ROB_ID"               );
 	 _component->port_map(name, "in_INSERT_OPERATION"            ,dest,"out_READ_QUEUE_OUT_OPERATION"            );
@@ -452,5 +453,5 @@
 	   if (_param->_have_port_ooo_engine_id)
 	   _component->port_map(name,"out_RETIRE_"+toString(i)+"_OOO_ENGINE_ID"        ,dest,"out_READ_UNIT_OUT_"+toString(i)+"_OOO_ENGINE_ID"        );
-	   if (_param->_have_port_packet_id)
+	   if (_param->_have_port_rob_ptr)
 	   _component->port_map(name,"out_RETIRE_"+toString(i)+"_ROB_ID"               ,dest,"out_READ_UNIT_OUT_"+toString(i)+"_PACKET_ID"            );
 	   _component->port_map(name,"out_RETIRE_"+toString(i)+"_OPERATION"            ,dest,"out_READ_UNIT_OUT_"+toString(i)+"_OPERATION"            );
@@ -535,7 +536,11 @@
      }
      
-
-#ifdef POSITION
-    _component->generate_file();
+#if DEBUG_Read_unit == true
+     _component->test_map();
+#endif
+
+#ifdef POSITION
+     if (usage_is_set(_usage,USE_POSITION))
+       _component->generate_file();
 #endif
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Read_unit_deallocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Read_unit_deallocation.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Read_unit_deallocation.cpp	(revision 88)
@@ -23,5 +23,5 @@
     log_printf(FUNC,Read_unit,FUNCTION,"Begin");
 
-    if (_usage & USE_SYSTEMC)
+    if (usage_is_set(_usage,USE_SYSTEMC))
       {
 	delete     in_CLOCK ;
@@ -37,5 +37,5 @@
 	if (_param->_have_port_ooo_engine_id)
 	delete     in_READ_UNIT_IN_OOO_ENGINE_ID        ;
-	if (_param->_have_port_packet_id)
+	if (_param->_have_port_rob_ptr)
 	delete     in_READ_UNIT_IN_PACKET_ID            ;
 	delete     in_READ_UNIT_IN_OPERATION            ;
@@ -66,5 +66,5 @@
 	if (_param->_have_port_ooo_engine_id)
 	delete [] out_READ_UNIT_OUT_OOO_ENGINE_ID        ;
-	if (_param->_have_port_packet_id)
+	if (_param->_have_port_rob_ptr)
 	delete [] out_READ_UNIT_OUT_PACKET_ID            ;
 	delete [] out_READ_UNIT_OUT_OPERATION            ;
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Read_unit_end_cycle.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Read_unit_end_cycle.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Read_unit_end_cycle.cpp	(revision 88)
@@ -25,5 +25,6 @@
 
 #ifdef STATISTICS
-    _stat->end_cycle();
+    if (usage_is_set(_usage,USE_STATISTICS))
+      _stat->end_cycle();
 #endif    
 
@@ -31,5 +32,6 @@
     // Evaluation before read the ouput signal
 //  sc_start(0);
-    _interfaces->testbench();
+    if (usage_is_set(_usage,USE_VHDL_TESTBENCH))
+      _interfaces->testbench();
 #endif
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/SelfTest/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/SelfTest/Makefile	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/SelfTest/Makefile	(revision 88)
@@ -24,4 +24,6 @@
 library_clean			: Execute_queue_library_clean
 
+local_clean			:
+
 include                         $(DIR_COMPONENT)/Makefile.deps
 include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/SelfTest/configuration.cfg
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/SelfTest/configuration.cfg	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/SelfTest/configuration.cfg	(revision 88)
@@ -1,8 +1,8 @@
 Execute_queue
-8	8	*2 # uint32_t size_queue         
+8	16	*2 # uint32_t size_queue         
 1	1	*2 # uint32_t nb_context         
 1	1	*2 # uint32_t nb_front_end       
 1	4	*2 # uint32_t nb_ooo_engine      
-32	32	*2 # uint32_t nb_packet          
+64	64	*2 # uint32_t nb_packet          
 32	32	*2 # uint32_t size_general_data  
 2	2	*2 # uint32_t size_special_data  
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/SelfTest/src/main.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/SelfTest/src/main.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/SelfTest/src/main.cpp	(revision 88)
@@ -54,5 +54,7 @@
 	 nb_packet          ,
 	 size_general_data  ,
-	 size_special_data  );
+	 size_special_data  ,
+         true // is_toplevel
+         );
       
       msg(_("%s"),param->print(1).c_str());
